## mingw-w64-opencsg-1.5.1-1.src.tar.zst

=== src/Makefile ===
#############################################################################
# Makefile for building: libopencsg.so.1.5.1
# Generated by qmake (2.01a) (Qt 4.8.6) on: Mo. Sep 15 22:00:30 2014
# Project:  src.pro
# Template: lib
# Command: /usr/lib/x86_64-linux-gnu/qt4/bin/qmake -o Makefile src.pro
#############################################################################

####### Compiler, tools and options

CC            = gcc
CXX           = g++
DEFINES       = 
CFLAGS        = -pipe -O2 -Wall -W -fPIC $(DEFINES)
CXXFLAGS      = -pipe -O2 -Wall -W -fPIC $(DEFINES)
INCPATH       = -I. -I../include -I.. -I/usr/X11R6/include
LINK          = g++
LFLAGS        = -Wl,-O1 -shared -Wl,-soname,libopencsg.so.1
LIBS          = $(SUBLIBS)  -L/usr/X11R6/lib64 -lGLEW -lGL 
AR            = ar cqs
RANLIB        = 
QMAKE         = /usr/lib/x86_64-linux-gnu/qt4/bin/qmake
TAR           = tar -cf
COMPRESS      = gzip -9f
COPY          = cp -f
SED           = sed
COPY_FILE     = $(COPY)
COPY_DIR      = $(COPY) -r
STRIP         = strip
INSTALL_FILE  = install -m 644 -p
INSTALL_DIR   = $(COPY_DIR)
INSTALL_PROGRAM = install -m 755 -p
DEL_FILE      = rm -f
SYMLINK       = ln -f -s
DEL_DIR       = rmdir
MOVE          = mv -f
CHK_DIR_EXISTS= test -d
MKDIR         = mkdir -p

####### Output directory

OBJECTS_DIR   = ./

####### Files

SOURCES       = area.cpp \
		batch.cpp \
		context.cpp \
		channelManager.cpp \
		frameBufferObject.cpp \
		frameBufferObjectExt.cpp \
		occlusionQuery.cpp \
		opencsgRender.cpp \
		openglHelper.cpp \
		pBufferTexture.cpp \
		primitive.cpp \
		primitiveHelper.cpp \
		renderGoldfeather.cpp \
		renderSCS.cpp \
		scissorMemo.cpp \
		settings.cpp \
		stencilManager.cpp \
		../RenderTexture/RenderTexture.cpp 
OBJECTS       = area.o \
		batch.o \
		context.o \
		channelManager.o \
		frameBufferObject.o \
		frameBufferObjectExt.o \
		occlusionQuery.o \
		opencsgRender.o \
		openglHelper.o \
		pBufferTexture.o \
		primitive.o \
		primitiveHelper.o \
		renderGoldfeather.o \
		renderSCS.o \
		scissorMemo.o \
		settings.o \
		stencilManager.o \
		RenderTexture.o
DIST          = src.pro
QMAKE_TARGET  = opencsg
DESTDIR       = ../lib/
TARGET        = libopencsg.so.1.5.1
TARGETA       = ../lib/libopencsg.a
TARGETD       = libopencsg.so.1.5.1
TARGET0       = libopencsg.so
TARGET1       = libopencsg.so.1
TARGET2       = libopencsg.so.1.5

first: all
####### Implicit rules

.SUFFIXES: .o .c .cpp .cc .cxx .C

.cpp.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"

.cc.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"

.cxx.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"

.C.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"

.c.o:
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"

####### Build rules

all: Makefile  ../lib/$(TARGET)

../lib/$(TARGET):  $(OBJECTS) $(SUBLIBS) $(OBJCOMP)  
	@$(CHK_DIR_EXISTS) ../lib/ || $(MKDIR) ../lib/ 
	-$(DEL_FILE) $(TARGET) $(TARGET0) $(TARGET1) $(TARGET2)
	$(LINK) $(LFLAGS) -o $(TARGET) $(OBJECTS) $(LIBS) $(OBJCOMP)
	-ln -s $(TARGET) $(TARGET0)
	-ln -s $(TARGET) $(TARGET1)
	-ln -s $(TARGET) $(TARGET2)
	-$(DEL_FILE) ../lib/$(TARGET)
	-$(DEL_FILE) ../lib/$(TARGET0)
	-$(DEL_FILE) ../lib/$(TARGET1)
	-$(DEL_FILE) ../lib/$(TARGET2)
	-$(MOVE) $(TARGET) $(TARGET0) $(TARGET1) $(TARGET2) ../lib/



staticlib: $(TARGETA)

$(TARGETA):  $(OBJECTS) $(OBJCOMP) 
	-$(DEL_FILE) $(TARGETA) 
	$(AR) $(TARGETA) $(OBJECTS)

dist: 
	@$(CHK_DIR_EXISTS) .tmp/opencsg1.5.1 || $(MKDIR) .tmp/opencsg1.5.1
	$(COPY_FILE) --parents $(SOURCES) $(DIST) .tmp/opencsg1.5.1/ && (cd `dirname .tmp/opencsg1.5.1` && $(TAR) opencsg1.5.1.tar opencsg1.5.1 && $(COMPRESS) opencsg1.5.1.tar) && $(MOVE) `dirname .tmp/opencsg1.5.1`/opencsg1.5.1.tar.gz . && $(DEL_FILE) -r .tmp/opencsg1.5.1


clean:compiler_clean 
	-$(DEL_FILE) $(OBJECTS)
	-$(DEL_FILE) *~ core *.core


####### Sub-libraries

distclean: clean
	-$(DEL_FILE) ../lib/$(TARGET) 
	-$(DEL_FILE) ../lib/$(TARGET0) ../lib/$(TARGET1) ../lib/$(TARGET2) $(TARGETA)
	-$(DEL_FILE) Makefile


check: first

compiler_rcc_make_all:
compiler_rcc_clean:
compiler_uic_make_all:
compiler_uic_clean:
compiler_image_collection_make_all: qmake_image_collection.cpp
compiler_image_collection_clean:
	-$(DEL_FILE) qmake_image_collection.cpp
compiler_yacc_decl_make_all:
compiler_yacc_decl_clean:
compiler_yacc_impl_make_all:
compiler_yacc_impl_clean:
compiler_lex_make_all:
compiler_lex_clean:
compiler_clean: 

####### Compile

area.o: area.cpp opencsgConfig.h \
		area.h \
		openglHelper.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o area.o area.cpp

batch.o: batch.cpp opencsgConfig.h \
		batch.h \
		primitiveHelper.h \
		area.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o batch.o batch.cpp

context.o: context.cpp opencsgConfig.h \
		context.h \
		offscreenBuffer.h \
		frameBufferObject.h \
		frameBufferObjectExt.h \
		pBufferTexture.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o context.o context.cpp

channelManager.o: channelManager.cpp opencsgConfig.h \
		channelManager.h \
		context.h \
		offscreenBuffer.h \
		openglHelper.h \
		area.h \
		settings.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o channelManager.o channelManager.cpp

frameBufferObject.o: frameBufferObject.cpp opencsgConfig.h \
		frameBufferObject.h \
		offscreenBuffer.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o frameBufferObject.o frameBufferObject.cpp

frameBufferObjectExt.o: frameBufferObjectExt.cpp opencsgConfig.h \
		frameBufferObjectExt.h \
		offscreenBuffer.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o frameBufferObjectExt.o frameBufferObjectExt.cpp

occlusionQuery.o: occlusionQuery.cpp opencsgConfig.h \
		occlusionQuery.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o occlusionQuery.o occlusionQuery.cpp

opencsgRender.o: opencsgRender.cpp opencsgConfig.h \
		opencsgRender.h \
		primitiveHelper.h \
		area.h \
		settings.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o opencsgRender.o opencsgRender.cpp

openglHelper.o: openglHelper.cpp opencsgConfig.h \
		openglHelper.h \
		area.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o openglHelper.o openglHelper.cpp

pBufferTexture.o: pBufferTexture.cpp opencsgConfig.h \
		pBufferTexture.h \
		offscreenBuffer.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o pBufferTexture.o pBufferTexture.cpp

primitive.o: primitive.cpp opencsgConfig.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o primitive.o primitive.cpp

primitiveHelper.o: primitiveHelper.cpp opencsgConfig.h \
		openglHelper.h \
		area.h \
		primitiveHelper.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o primitiveHelper.o primitiveHelper.cpp

renderGoldfeather.o: renderGoldfeather.cpp opencsgConfig.h \
		opencsgRender.h \
		batch.h \
		channelManager.h \
		occlusionQuery.h \
		openglHelper.h \
		area.h \
		primitiveHelper.h \
		scissorMemo.h \
		stencilManager.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o renderGoldfeather.o renderGoldfeather.cpp

renderSCS.o: renderSCS.cpp opencsgConfig.h \
		opencsgRender.h \
		batch.h \
		channelManager.h \
		context.h \
		occlusionQuery.h \
		openglHelper.h \
		area.h \
		primitiveHelper.h \
		scissorMemo.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o renderSCS.o renderSCS.cpp

scissorMemo.o: scissorMemo.cpp opencsgConfig.h \
		openglHelper.h \
		area.h \
		scissorMemo.h \
		channelManager.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o scissorMemo.o scissorMemo.cpp

settings.o: settings.cpp opencsgConfig.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o settings.o settings.cpp

stencilManager.o: stencilManager.cpp opencsgConfig.h \
		area.h \
		openglHelper.h \
		stencilManager.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o stencilManager.o stencilManager.cpp

RenderTexture.o: ../RenderTexture/RenderTexture.cpp ../RenderTexture/RenderTexture.h
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o RenderTexture.o ../RenderTexture/RenderTexture.cpp

####### Install

install_target: first FORCE
	@$(CHK_DIR_EXISTS) $(INSTALL_ROOT)/usr/local/lib/ || $(MKDIR) $(INSTALL_ROOT)/usr/local/lib/ 
	-$(INSTALL_PROGRAM) "../lib/$(TARGET)" "$(INSTALL_ROOT)/usr/local/lib/$(TARGET)"
	-$(STRIP) --strip-unneeded "$(INSTALL_ROOT)/usr/local/lib/$(TARGET)"
	-$(SYMLINK) "$(TARGET)" "$(INSTALL_ROOT)/usr/local/lib/$(TARGET0)"
	-$(SYMLINK) "$(TARGET)" "$(INSTALL_ROOT)/usr/local/lib/$(TARGET1)"
	-$(SYMLINK) "$(TARGET)" "$(INSTALL_ROOT)/usr/local/lib/$(TARGET2)"

uninstall_target:  FORCE
	-$(DEL_FILE) "$(INSTALL_ROOT)/usr/local/lib/$(TARGET)" 
	 -$(DEL_FILE) "$(INSTALL_ROOT)/usr/local/lib/$(TARGET0)" 
	 -$(DEL_FILE) "$(INSTALL_ROOT)/usr/local/lib/$(TARGET1)" 
	 -$(DEL_FILE) "$(INSTALL_ROOT)/usr/local/lib/$(TARGET2)"
	-$(DEL_DIR) $(INSTALL_ROOT)/usr/local/lib/ 


install_headers: first FORCE
	@$(CHK_DIR_EXISTS) $(INSTALL_ROOT)/usr/local/include/ || $(MKDIR) $(INSTALL_ROOT)/usr/local/include/ 
	-$(INSTALL_FILE) ../include/opencsg.h $(INSTALL_ROOT)/usr/local/include/


uninstall_headers:  FORCE
	-$(DEL_FILE) -r $(INSTALL_ROOT)/usr/local/include/opencsg.h
	-$(DEL_DIR) $(INSTALL_ROOT)/usr/local/include/ 


install:  install_target install_headers  FORCE

uninstall: uninstall_target uninstall_headers   FORCE

FORCE:

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=opencsg
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.5.1
pkgrel=1
pkgdesc="Library for image-based CSG rendering using OpenGL (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32' 'clangarm64')
license=("GPL2")
url="http://www.opencsg.org"
depends=("${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         # "${MINGW_PACKAGE_PREFIX}-freeglut" # need for building example
         )
makedepends=("${MINGW_PACKAGE_PREFIX}-cc")
options=(!strip staticlibs !buildflags)
source=("http://www.opencsg.org/OpenCSG-${pkgver}.tar.gz"
        01-makefile-mingw.patch
        02-qmake-mingw.patch)
sha256sums=('7adb7ec7650d803d9cb54d06572fb5ba5aca8f23e6ccb75b73c17756a9ab46e3'
            '29e504d0fe2d8576202f92149688fc9eeecafee135463943aca13b786e2ac4e5'
            '87be0437e05a346e0bc082ad405c9ec9081f51bba03df8ec6c65ade7e934f99f')

prepare() {
  cd "${srcdir}/OpenCSG-${pkgver}"
  patch -p1 -i ${srcdir}/01-makefile-mingw.patch
  patch -p1 -i ${srcdir}/02-qmake-mingw.patch
}

build() {
  [[ -d "${srcdir}/build-${MSYSTEM}" ]] && rm -rf "${srcdir}/build-${MSYSTEM}"
  cp -r "${srcdir}/OpenCSG-${pkgver}" "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  #rm -f example/Makefile src/Makefile
  #${MINGW_PREFIX}/bin/qmake -recursive opencsg.pro
  #make

  make CC=${CC} CXX=${CXX} LINK=${MINGW_PREFIX}/bin/c++.exe all staticlib -C src
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  make LINK=${MINGW_PREFIX}/bin/c++.exe prefix=${MINGW_PREFIX} INSTALL_ROOT=${pkgdir} install -C src
  #install -D lib/libopencsg.so.$pkgver "${pkgdir}${MINGW_PREFIX}/lib/libopencsg.so.$pkgver"
  #install -D include/opencsg.h "${pkgdir}${MINGW_PREFIX}/include/opencsg.h"
}
